CNT             EQU     61H
COLS            EQU     62H
NEXTPTR         EQU 	63H
SCANLINE        EQU 	64H
                ORG     00H
                AJMP    RED
                ORG     0BH
                AJMP    TIMER0
RED:            MOV     SP,#68H
                ACALL   INIT
                SETB    TR0
                MOV     DPTR,#MSG
                MOV	     R0,#20H		;PATTERN 1
                MOV	     R4,#0	
                MOV     R2,#32   	     ;32 BYTES
S1:             MOV	     A,R4
                MOVC    A,@A+DPTR
                MOV     @R0,A
                INC     R0
                INC     R4
                DJNZ    R2,S1
S2:             MOV	     A,NEXTPTR
	           ADD	     A,#32
	           CJNE	A,#160,S3	;32*4
S3:             JC	     S4
	           CLR	     A
S4:	           MOV	     NEXTPTR,A
 	           MOV 	R4,A
 	           MOV 	R0,#40H		;PATTERN 2
	           MOV 	R2,#32		;32 BYTES
S5:        	 MOV 	A,R4
                MOVC 	A,@A+DPTR
	           MOV 	@R0,A
                INC	     R0
	           INC 	R4
	           DJNZ	R2,S5
	           MOV 	R3,#16		;16 COLUMNS
S6:	           ACALL	DELAY
	           ACALL	SHIFTL
	           DJNZ	R3,S6
	           SJMP	S2
;
INIT:           MOV     CNT,#4
                MOV     R1,#20H
	           MOV 	NEXTPTR,#0
                MOV     SCANLINE,#0
                MOV     COLS,#16
                CLR     P1.4            ;LATCH 0-7
                CLR     P1.5            ;LATCH 8-15
                MOV     TMOD,#2
                SETB    EA
                SETB    ET0
                MOV     TH0,#6
                MOV     TL0,#6
                SETB    TR0
                RET
;
DELAY:          PUSH    A
                MOV     R5,#2
D1              MOV     R6,#250
D2:             MOV     R7,#200
                DJNZ    R7,$
                DJNZ    R6,D2
                DJNZ    R5,D1
                POP     A
                RET
;
SHIFTL:         PUSH    A
                SETB    RS0
	           CLR 	TR0
                MOV     R0,#20H
                MOV     R1,#22H
                MOV     R2,#32
SL1:	           MOV     A,@R1
                MOV     @R0,A
                INC     R0
	           INC 	R0
                INC     R1
	           INC 	R1
                DJNZ    R2,SL1
                MOV     R0,#21H
                MOV     R1,#23H
                MOV     R2,#32
SL2:	           MOV     A,@R1
                MOV     @R0,A
                INC     R0
	           INC 	R0
               INC     R1
	           INC 	R1
                DJNZ    R2,SL2
	           SETB	TR0
                CLR     RS0
                POP     A
                RET
;
TIMER0:         PUSH    A
	           PUSH	PSW
	           CLR 	RS0
                CLR     TR0
                DJNZ    CNT,EXIT0
                MOV     CNT,#4
                MOV     A,@R1
                MOV     P2,A            ;R0-R7             
                SETB    P1.5            ;LATCH
                CLR     P1.5
;*******************************************************
                MOV     P0,A
                CLR    P1.7            ;LATCH
                CLR     P1.7
;********************************************************
                INC     R1
                MOV     A,@R1
                MOV     P2,A            ;R8-R15
                SETB    P1.4            ;LATCH
                CLR     P1.4
;*********************************************************
                MOV     P0,A
                CLR    P1.6            ;LATCH
                CLR     P1.6
;*********************************************************
                INC     R1
                MOV     A,SCANLINE
                MOV     P1,A
                INC     SCANLINE
                DJNZ    COLS,EXIT0
                MOV     COLS,#16
	           MOV 	R1,#20H
                MOV     SCANLINE,#0
EXIT0:          SETB    TR0
	           POP 	PSW
	           POP     A                        
                RETI               
;
MSG:    
                DB      00H,00H,00H,00H	
	           DB  	00H,00H,00H,00H
	           DB      00H,00H,00H,00H		
	           DB   	00H,00H,00H,00H
	           DB  	00H,00H,00H,00H
	           DB  	00H,00H,00H,00H
	           DB  	00H,00H,00H,00H 
	           DB  	00H,00H,00H,00H
       
;
                DB      FFH,FFH,01H,C0H	
	           DB  	FFH,BFH,FFH,BFH
	           DB      FFH,BFH,FFH,BFH		
	           DB   	01H,C0H,FFH,FFH
	           DB  	FFH,FFH,01H,80H
	           DB  	FDH,FEH,FDH,FEH
	           DB  	FDH,FEH,FDH,FEH 
	           DB  	03H,FFH,FFH,FFH
;
	           DB  	FFH,FFH,7FH,FEH 
	           DB  	7FH,FEH,7FH,FEH 	
	           DB  	7FH,FEH,7FH,FEH	
	           DB  	7FH,FEH,FFH,FFH
	           DB  	FFH,FFH,C3H,87H
	           DB  	FDH,BBH,FDH,BDH
	           DB  	FDH,BEH,7DH,BFH
	           DB  	83H,BFH,FFH,FFH	 
;
	           DB      FFH,FFH,FDH,FFH
                DB      FDH,FFH,FDH,FFH
                DB      01H,80H,FDH,FFH
                DB      FDH,FFH,FDH,FFH
	           DB 	     FFH,FFH,FFH,FFH
                DB      01H,80H,7DH,BFH
                DB      7DH,BFH,7DH,BFH
                DB      7DH,BFH,FFH,FFH
;
	           DB  	FFH,FFH,C3H,87H
	           DB  	BDH,BFH,7DH,BFH
	           DB  	FDH,BEH,FDH,BDH
	           DB  	C3H,C3H,FFH,FFH
	           DB   	FDH,FFH,FDH,FFH
	           DB  	FDH,FFH,01H,80H
	           DB  	FDH,FFH,FDH,FFH
	           DB  	FDH,FFH,FFH,FFH
                END
